<?php
// File: $Id: class.SF_GUI_RESSOURCES_InternalLink.php,v 1.1.4.5.2.3 2007/04/24 15:58:32 bjoern Exp $
// +----------------------------------------------------------------------+
// | Version: Sefrengo $Name:  $
// +----------------------------------------------------------------------+
// | Copyright (c) 2005 - 2007 sefrengo.org <info@sefrengo.org>           |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify |
// | it under the terms of the GNU General Public License                 |
// |                                                                      |
// | This program is subject to the GPL license, that is bundled with     |
// | this package in the file LICENSE.TXT.                                |
// | If you did not receive a copy of the GNU General Public License      |
// | along with this program write to the Free Software Foundation, Inc., |
// | 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA               |
// |                                                                      |
// | This program is distributed in the hope that it will be useful,      |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
// | GNU General Public License for more details.                         |
// |                                                                      |
// +----------------------------------------------------------------------+
// + Autor: $Author: bjoern $
// +----------------------------------------------------------------------+
// + Revision: $Revision: 1.1.4.5.2.3 $
// +----------------------------------------------------------------------+
// + Description:
// +----------------------------------------------------------------------+
// + Changes:
// +----------------------------------------------------------------------+
// + ToDo:
// +----------------------------------------------------------------------+


$GLOBALS['sf_factory']->requireClass('GUI/RESSOURCES', 'Abstract');
//require_once ($_api_path.'GUI/RESSOURCES/class.SF_GUI_RESSOURCES_Abstract.php');

class SF_GUI_RESSOURCES_InternalLink extends SF_GUI_RESSOURCES_Abstract{
	
	var $custom_config = array();
	
	function SF_GUI_RESSOURCES_InternalLink() {
		global $cms_lang;
		$this->lang =& $cms_lang;
	}
			
	function getRessourceName() {
		return 'internalLink';
	}
	
	function getRessourceChooserImage() {
		return 'icons/rb_rsc_links.gif';
	}
	
	function getRessourceChooserDisplayedName() {
		return $this->lang['rb_res_internal_links'];	
	}
	
	function getStartPosition() {
		return 0;
	}

	function generatePathwayReleatedData($current_position) {
		
		$arr_rev = $this->_getPathwayArray($current_position);
		
		$level=0;
		$this->_addPathway($this->getRessourceChooserDisplayedName(), 0, $level);
		foreach($arr_rev AS $v) {
			//name, position, level
			$this->_addPathway($v['name'], $v['position'], ++$level);
		}
		
		if($current_position != $this->getStartPosition()) {
			$this->_setPathwayOneUpIsActive(true);
			$this->_setPathwayOneUpPosition( $arr_rev[ (count($arr_rev) -2) ]['position'] );
		} else {
			$this->_setPathwayOneUpIsActive(false);
		}
		
		$this->_setDetailswitchIsActive(true);

	}
	
	function generateCatData($current_position) {
		global $db, $perm, $cms_db, $client, $lang, $cfg_client, $cfg_cms;
		
		//get pathway for picker_name
		$title_pre = $this-> _getPathwayAsString($current_position);
		
		$sql = "SELECT 
					A.*, B.parent, D.name AS firstname, D.surname, D.username
				FROM 
					".$cms_db['cat_lang']."  A 
					LEFT JOIN ".$cms_db['cat']."  B USING(idcat) ,
					".$cms_db['users']." D
				WHERE 
					A.idlang = '$lang'
					AND A.author = D.user_id
					AND B.parent = '$current_position'
				ORDER BY B.sortindex";
		$db->query($sql);
		while ($db->next_record()) {
			if (! $perm->have_perm(1, 'cat', $db->f('idcat')) ) {
					continue;
			}
			
			$author = $db->f('username') .
						($db->f('firstname') != '' || $db->f('surname') != '' 
							? ' ('.$db->f('firstname'). ' ' . $db->f('surname').')': '');
			$this->_addCat($db->f('name'), 'cms://idcat='.$db->f('idcat'), 
								array('description' => $db->f('description'), 
										'detail_description1' => '<strong>'.$this->lang['rb_description'].': </strong>'.$db->f('description').'<br />',
										'detail_description2' => '<strong>'.$this->lang['rb_author'].': </strong>'.$author.'<br />',
										'detail_description3' => '',
										'detail_description4' => '',
										'detail_description5' => ''), 
								$db->f('idcat'), 'cat_link', true, false, $title_pre);
		}
	}
	
	function generateItemData($current_position) {
		global $db, $perm, $cms_db, $client, $lang, $cfg_client, $cfg_cms;
		
		//get pathway for picker_name
		$title_pre = $this-> _getPathwayAsString($current_position);
		
		$sql = "SELECT 
					D.idcatside, D.idcat, D.sortindex, D.is_start, F.title, F.summary, 
					U.name AS firstname, U.surname, U.username
				FROM 
					".$cms_db['cat_side']."  D 
					LEFT JOIN ".$cms_db['side']."  E USING(idside) 
					LEFT JOIN ".$cms_db['side_lang']."  F USING(idside),
					".$cms_db['users']." U
				WHERE 
					E.idclient='$client'
					AND D.idcat = '".$current_position."'
					AND F.idlang='$lang'
					AND F.author = U.user_id
				ORDER BY D.sortindex";
		$db->query($sql);
		while ($db->next_record()) {
			if (! $perm->have_perm(17, 'side', $db->f('idcatside'), $db->f('idcat')) ) {
					continue;
			}
			$author = $db->f('username') .
						($db->f('firstname') != '' || $db->f('surname') != '' 
							? ' ('.$db->f('firstname'). ' ' . $db->f('surname').')': '');
			$image = $db->f('is_start') == 1 ? 'item_link_startpage':'item_link';
			$this->_addItem($db->f('title'),  'cms://idcatside='.$db->f('idcatside'), 
						array('title' =>  $db->f('title'),
								'description' => $db->f('summary'),
								'detail_description1' => '<strong>'.$this->lang['rb_description'].': </strong>'.$db->f('summary').'<br />',
								'detail_description2' => '<strong>'.$this->lang['rb_author'].': </strong>'.$author.'<br />',
								'detail_description3' => '',
								'detail_description4' => '',
								'detail_description5' => ''								
								) , 
								$image, true, false, false, $title_pre);
		}		
	}
	
	/*
	 * PRIVATE METHODS START HERE
	 */
	function _getPathwayArray($idcat) {
		global $db, $perm, $cms_db, $client, $lang, $cfg_client, $cfg_cms;
		
		$pos = $idcat;
		$arr_pway = array();
		$control = 0;
		 while($pos > 0 && ++$control < 50) {
			$sql = "SELECT *
			FROM ".$cms_db['cat_lang']." C
			LEFT JOIN ".$cms_db['cat']." D USING(idcat)
			WHERE C.idcat = '".$pos."'
			AND C.idlang = '".$lang."'
			LIMIT 1";
			$db->query($sql);
			$db->next_record();
			$item['name'] = $db->f('name');
			$item['position'] = $db->f('idcat');
			$pos = $db->f('parent');
			array_push($arr_pway, $item);		
		}
		
		$arr_rev = array_reverse($arr_pway);
		
		return $arr_rev;
	} 
	
	function _getPathwayAsString($idcat) {
		$pathway = $this->_getPathwayArray($idcat);
		$title_pre = '';
		foreach($pathway AS $v) {
			//name, position, level
			$title_pre .= $v['name'] .'/';
		}
		return $title_pre;
	}
	 	
	
}


?>